//+------------------------------------------------------------------+
//|                                                   mass-index.mq4 |
//|        2011 Best-metatrader-indicators.com. All rights reserved |
//|                        http://www.best-metatrader-indicators.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011 Best-metatrader-indicators.com."
#property link      "http://www.best-metatrader-indicators.com"

//----
#property  indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 27
#property indicator_level2 26.5
#property indicator_levelcolor Blue
//---- input parameters
extern int  EMAPeriod = 9;
extern int  SecondPeriod = 9;
extern int  SumPeriod = 25;
//---- buffers
double MI[];
double HL[];
double HLaverage[];
double EMA2[];
string Copyright="\xA9 WWW.BEST-METATRADER-INDICATORS.COM";  
string MPrefix="FI";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   string name;
   name = "Mass Index(" + EMAPeriod + "," + SecondPeriod + "," + SumPeriod + ")";
   IndicatorBuffers(4);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, MI);
   SetIndexLabel(0, name);
   SetIndexEmptyValue(0, 0.0);
   SetIndexBuffer(1, HL);
   SetIndexEmptyValue(1, 0.0);
   SetIndexBuffer(2, HLaverage);
   SetIndexEmptyValue(2, 0.0);
   SetIndexBuffer(3, EMA2);
   SetIndexEmptyValue(3, 0.0);
   IndicatorShortName(name);
   IndicatorDigits(2);   
//----
   DL("001", Copyright, 5, 20,Gold,"Arial",10,0); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ClearObjects(); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   int limit,i;
//----
   if(counted_bars < 0) 
      return(-1);
   if(counted_bars == 0) 
     {
       limit = Bars - 1;
       for(i = limit; i >= 0; i--)
           HL[i] = High[i] - Low[i];
       for(i = limit - EMAPeriod; i >= 0; i--)
           HLaverage[i]=iMAOnArray(HL,0,EMAPeriod,0,MODE_EMA,i);
       for(i = limit - EMAPeriod - SecondPeriod; i >= 0; i--)
           EMA2[i] = HLaverage[i] / iMAOnArray(HLaverage, 0, SecondPeriod, 0, MODE_EMA, i);
       for(i = limit - EMAPeriod - SecondPeriod - SumPeriod; i >= 0; i--)
           MI[i] = iMAOnArray(EMA2, 0, SumPeriod, 0, MODE_SMA, i)*SumPeriod;
     }
   if(counted_bars > 0) 
     {
       limit = Bars - counted_bars;
       for(i = limit; i >= 0; i--)
           HL[i] = High[i] -Low[i];
       for(i = limit; i >= 0; i--)
           HLaverage[i] = iMAOnArray(HL, 0, EMAPeriod, 0, MODE_EMA, i);
       for(i = limit; i >= 0; i--)
           EMA2[i] = HLaverage[i] / iMAOnArray(HLaverage, 0, SecondPeriod, 0, MODE_EMA, i);
       for(i = limit; i >= 0; i--)
           MI[i] = iMAOnArray(EMA2, 0, SumPeriod, 0, MODE_SMA, i)*SumPeriod;
     }            
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| DL function                                                      |
//+------------------------------------------------------------------+
 void DL(string label, string text, int x, int y, color clr, string FontName = "Arial",int FontSize = 12, int typeCorner = 1)
 
{
   string labelIndicator = MPrefix + label;   
   if (ObjectFind(labelIndicator) == -1)
   {
      ObjectCreate(labelIndicator, OBJ_LABEL, 0, 0, 0);
  }
   
   ObjectSet(labelIndicator, OBJPROP_CORNER, typeCorner);
   ObjectSet(labelIndicator, OBJPROP_XDISTANCE, x);
   ObjectSet(labelIndicator, OBJPROP_YDISTANCE, y);
   ObjectSetText(labelIndicator, text, FontSize, FontName, clr);
  
}  

//+------------------------------------------------------------------+
//| ClearObjects function                                            |
//+------------------------------------------------------------------+
void ClearObjects() 
{ 
  for(int i=0;i<ObjectsTotal();i++) 
  if(StringFind(ObjectName(i),MPrefix)==0) { ObjectDelete(ObjectName(i)); i--; } 
}
//+------------------------------------------------------------------+